package org.websparrow;

import java.io.File;
import java.io.FileInputStream;
import java.io.InputStream;
import java.sql.ResultSet;
import java.util.HashMap;

import org.apache.struts2.ServletActionContext;

import com.opensymphony.xwork2.ActionSupport;

import net.sf.jasperreports.engine.JRResultSetDataSource;
import net.sf.jasperreports.engine.JasperCompileManager;
import net.sf.jasperreports.engine.JasperExportManager;
import net.sf.jasperreports.engine.JasperFillManager;
import net.sf.jasperreports.engine.JasperPrint;
import net.sf.jasperreports.engine.JasperReport;

public class ReportAction extends ActionSupport {

	public ResultSet rs = null;
	public String submit = null;
	public InputStream fileInputStream;
	public String jasperPath = "";
	public String pdfName = "";
	public String rpt = "";

	@Override
	public String execute() throws Exception {
		try {
			if (submit.equals("pdf")) {
				rs = new ReportDAO().getPdf();
				jasperPath = ServletActionContext.getServletContext().getRealPath("/Reports");
				pdfName = "Student Report";
				rpt = "studentReport.jrxml";
				JRResultSetDataSource resultSetDataSource = new JRResultSetDataSource(rs);
				HashMap<String, Object> pm = new HashMap<String, Object>();
				String logo = jasperPath + "/ws.jpg";
				pm.put("logo", logo);
				JasperReport jr = JasperCompileManager.compileReport(jasperPath + "/" + rpt);
				JasperPrint jp = JasperFillManager.fillReport(jr, pm, resultSetDataSource);
				JasperExportManager.exportReportToPdfFile(jp, jasperPath + pdfName + ".pdf");
				fileInputStream = new FileInputStream(new File(jasperPath + pdfName + ".pdf"));

			}
		} catch (Exception e) {
			e.printStackTrace();
		}
		return "SUCCESS";

	}

	public ResultSet getRs() {
		return rs;
	}

	public void setRs(ResultSet rs) {
		this.rs = rs;
	}

	public String getSubmit() {
		return submit;
	}

	public void setSubmit(String submit) {
		this.submit = submit;
	}

	public InputStream getFileInputStream() {
		return fileInputStream;
	}

	public void setFileInputStream(InputStream fileInputStream) {
		this.fileInputStream = fileInputStream;
	}

	public String getJasperPath() {
		return jasperPath;
	}

	public void setJasperPath(String jasperPath) {
		this.jasperPath = jasperPath;
	}

	public String getPdfName() {
		return pdfName;
	}

	public void setPdfName(String pdfName) {
		this.pdfName = pdfName;
	}

	public String getRpt() {
		return rpt;
	}

	public void setRpt(String rpt) {
		this.rpt = rpt;
	}

}
